/**
Înainte de butonare, la pb. de backtracking tre' să identificăm:
1) Domenii: între cine și cine se plimbă fiecare x[k]
    adică lik = limita inițială pt. x[k]
          lfk = limita finală pt. x[k]
(de exemplu la permutări sunt 1 și n)

2) Condiția de valid: verif. dacă x[k] proaspăt pus
poate conduce la soluție. Aici se gândește oarecum ca la
inducție, adică presupunem că elemn. de dinainte au fost deja
validate.

3) Conidția de soluție: ce trebuie să se întâmple cu un șir proaspăt
validat pentru ca, în plus, să fie și soluție.
*/
#include <iostream>
using namespace std;

int main()
{
    codul generic:
    x[k=1]=li1 (limita inițială pentru x[1])
    while(k>=1)
        if(x[k]<=lfk)
            if(valid)///în principiu dedicați o funcție
                if(soluție)///fie o funcție, fie o condiție
                {
                    afișare_soluție;
                    x[k]++;
                }
                else
                    x[++k]=lik;
            else
                x[k]++;
        else
            x[--k]++;
    return 0;
}
